//A very complex mutator that stores huge clots of data for use with custom weapons.
//Stored serverside.

class MSCCraftingMutator extends Mutator config(MSMTL);

var config string AccountIPs[100];
var config string AccountInfo[100];

function Timer()
{
 local MSCCraftTurnIn A;
 local CustomWeaponShopButton A2;
 local CustomWeaponCheckButton A3;
 
 forEach AllActors(class'MSCCraftTurnIn', A)
 {
  if ((A != None) && (A.Storage == None))
  {
   A.Storage = Self;
   log(""$A$" has had its Crafting Mutator corrected!");
  }
 }

 forEach AllActors(class'CustomWeaponShopButton', A2)
 {
  if ((A2 != None) && (A2.Storage == None))
  {
   A2.Storage = Self;
   log(""$A2$" has had its Crafting Mutator corrected!");
  }
 }

 forEach AllActors(class'CustomWeaponCheckButton', A3)
 {
  if ((A3 != None) && (A3.Storage == None))
  {
   A3.Storage = Self;
   log(""$A3$" has had its Crafting Mutator corrected!");
  }
 }
}

function PostBeginPlay()
{
 local MSCCraftTurnIn A;
 local CustomWeaponShopButton A2;
 local CustomWeaponCheckButton A3;

	Level.Game.BaseMutator.AddMutator(Self);
	Level.Game.RegisterDamageMutator(Self);
        SetTimer(3, True);
 
 forEach AllActors(class'MSCCraftTurnIn', A)
 {
  if ((A != None) && (A.Storage == None))
  {
   A.Storage = Self;
   log(""$A$" has had its Crafting Mutator corrected!");
  }
 }

 forEach AllActors(class'CustomWeaponShopButton', A2)
 {
  if ((A2 != None) && (A2.Storage == None))
  {
   A2.Storage = Self;
   log(""$A2$" has had its Crafting Mutator corrected!");
  }
 }

 forEach AllActors(class'CustomWeaponCheckButton', A3)
 {
  if ((A3 != None) && (A3.Storage == None))
  {
   A3.Storage = Self;
   log(""$A3$" has had its Crafting Mutator corrected!");
  }
 }
}

function int GetAccountNum(string IPtoUse)
{
	local int i;

	for (i=0; i<99; i++)
		if (AccountIPs[i] ~= IPtoUse)
		{
	 		//BroadcastMessage("|p4FROBBER ACCOUNT NUM IS "$i$".");
			return i;
		}
        return -1;
}

function AddWeaponInfo(string info, string IP)
{
                       if (GetAccountNum(IP) == -1)
                       {
			MakeNewAccount(IP);
		       }
                       if (GetAccountNum(IP) > -1)
			AccountInfo[GetAccountNum(IP)] = info;

			SaveConfig();
}

function string GetWeaponInfo(string IP)
{
                       if (GetAccountNum(IP) > -1)
		       {
	 		//BroadcastMessage("|p4FROBBER INFO IS "$AccountInfo[GetAccountNum(IP)]$".");
			return AccountInfo[GetAccountNum(IP)];
		       }

		       //return "";
}

function MakeNewAccount(string IPtoUse)
{
	local int i;

	if (GetAccountNum(IPtoUse) > -1)
	 return;
        else if (GetAccountNum(IPtoUse) == -1)

	for (i=0; i<99; i++)
		if (AccountIPs[i] ~= "")
                {
			AccountIPs[i] = IPtoUse; 
                        SaveConfig();         
                        return;
                }
}

function Mutate(string BaseS, PlayerPawn Player)
{
 local string FrobbersIP;
 local string S, TrimS;
 local int WNum, MNum, bSpecAcc, bSpecPen, bSpecDam, bSpecScope, bSpecSilencer, bSpecKnockback, bSpecClipSize, bSpecRecoil, bSpecRange;
 local class<Ammo> A;
 local sound s1, s2, s3, s4;

 if (inStr(CAPS(BaseS), "SORTTEST") > -1)
 {
	 TrimS = Right(BaseS, Len(BaseS) - inStr(CAPS(BaseS), "SORTTEST") - 8);
	 
  	 SortInfo(TrimS, WNum, MNum, A, s1, s2, s3, s4, S);
	 SortSpecs(S, bSpecAcc, bSpecPen, bSpecDam, bSpecScope, bSpecSilencer, bSpecKnockback, bSpecClipSize, bSpecRecoil, bSpecRange);
 }
 
 Super.Mutate(BaseS, Player);
}





function SortSpecs(String BaseSpecs,  out int bSpecAcc, out int bSpecPen, out int bSpecDam, out int bSpecScope, out int bSpecSilencer, out int bSpecKnockback, out int bSpecClipSize, out int bSpecRecoil, out int bSpecRange)
{
 local string S;
 
 S = BaseSpecs;
 
 bSpecAcc = Int(Bool( Left(S, inStr(S, ",")) ));
 S = Right(S, Len(S) - inStr(S, ",") - 1);
 
 bSpecPen = Int(Bool( Left(S, inStr(S, ",")) ));
 S = Right(S, Len(S) - inStr(S, ",") - 1);
 
 bSpecDam = Int(Bool( Left(S, inStr(S, ",")) ));
 S = Right(S, Len(S) - inStr(S, ",") - 1);
 
 bSpecScope = Int(Bool( Left(S, inStr(S, ",")) ));
 S = Right(S, Len(S) - inStr(S, ",") - 1);
 
 bSpecSilencer = Int(Bool( Left(S, inStr(S, ",")) ));
 S = Right(S, Len(S) - inStr(S, ",") - 1);
 
 bSpecKnockback = Int(Bool( Left(S, inStr(S, ",")) ));
 S = Right(S, Len(S) - inStr(S, ",") - 1);
 
 bSpecClipSize = Int(Bool( Left(S, inStr(S, ",")) ));
 S = Right(S, Len(S) - inStr(S, ",") - 1);
 
 bSpecRecoil = Int(Bool( Left(S, inStr(S, ",")) ));
 S = Right(S, Len(S) - inStr(S, ",") - 1);
 
 bSpecRange = Int(Bool( Left(S, inStr(S, ",")) ));
 
 BroadcastMessage(bSpecAcc@bSpecPen@bSpecDam@bSpecScope@bSpecSilencer@bSpecKnockback@bSpecClipSize@bSpecRecoil@bSpecRange);
}

function SortInfo(String Base, out int WNum, out int MNum, out class<Ammo> A, out sound s1, out sound s2, out sound s3, out sound s4, out String Specs)
{
 local string S, CurS;
 
 S = Base;
 
 //Weapon Type
 //---------------
 WNum = Int(Left(S, inStr(S, ",")));
 S = Right(S, Len(S) - inStr(S, ",") - 1);
 
 //Weapon Mesh
 //---------------
 MNum = Int(Left(S, inStr(S, ",")));
 S = Right(S, Len(S) - inStr(S, ",") - 1);
 
 //Ammo Type
 //---------------
 A = class<Ammo>( DynamicLoadObject( Left(S, inStr(S, ",")), class'Class') );
 S = Right(S, Len(S) - inStr(S, ",") - 1);
 
 //Fire Sound
 //---------------
 S1 = Sound( DynamicLoadObject( Left(S, inStr(S, ",")), class'Sound') );
 S = Right(S, Len(S) - inStr(S, ",") - 1);
 
 //Reload Sound
 //---------------
 S2 = Sound( DynamicLoadObject( Left(S, inStr(S, ",")), class'Sound') );
 S = Right(S, Len(S) - inStr(S, ",") - 1);
 
 //FinishReload Sound
 //---------------
 S3 = Sound( DynamicLoadObject( Left(S, inStr(S, ",")), class'Sound') );
 S = Right(S, Len(S) - inStr(S, ",") - 1);
 
 //Select Sound
 //---------------
 S4 = Sound( DynamicLoadObject( Left(S, inStr(S, ",")), class'Sound') );
 S = Right(S, Len(S) - inStr(S, ",") - 1);
 
 //A, P, D, SC, SL, KB, CS, RC, RA - the 9 specs (now fits on one line!)
 //---------------
 
 Specs = S;

 /*bSpecAcc = Int(Left(S, inStr(S, ",")));
 S = Right(S, Len(S) - inStr(S, ",") - 1);
 
 bSpecPen = Int(Left(S, inStr(S, ",")));
 S = Right(S, Len(S) - inStr(S, ",") - 1);
 
 bSpecDam = Int(Left(S, inStr(S, ",")));
 S = Right(S, Len(S) - inStr(S, ",") - 1);
 
 bSpecScope = Int(Left(S, inStr(S, ",")));
 S = Right(S, Len(S) - inStr(S, ",") - 1);
 
 bSpecSilencer = Int(Left(S, inStr(S, ",")));
 S = Right(S, Len(S) - inStr(S, ",") - 1);
 
 bSpecKnockback = Int(Left(S, inStr(S, ",")));
 S = Right(S, Len(S) - inStr(S, ",") - 1);
 
 bSpecClipSize = Int(Left(S, inStr(S, ",")));
 S = Right(S, Len(S) - inStr(S, ",") - 1);
 
 bSpecRecoil = Int(Left(S, inStr(S, ",")));
 S = Right(S, Len(S) - inStr(S, ",") - 1);
 
 bSpecRange = Int(Left(S, inStr(S, ",")));*/
 
 //BroadcastMessage(WNum@MNum@A@s1@s2@s3@s4@bSpecAcc@bSpecPen@bSpecDam@bSpecScope@bSpecSilencer@bSpecKnockback@bSpecClipSize@bSpecRecoil@bSpecRange);

 BroadcastMessage(WNum@MNum@A@s1@s2@s3@s4);
 BroadcastMessage(Specs);
}





defaultproperties
{
}
