//=============================================================================
// WeaponBarrett.
//=============================================================================
class MSCWeaponBarrett extends MarkistanGuns;

var float	mpNoScopeMult;

simulated function PreBeginPlay()
{
	Super.PreBeginPlay();

	// If this is a netgame, then override defaults
	if ( Level.NetMode != NM_StandAlone )
	{
		HitDamage = mpHitDamage;
		BaseAccuracy = mpBaseAccuracy;
		ReloadTime = mpReloadTime;
		AccurateRange = mpAccurateRange;
		MaxRange = mpMaxRange;
		//ReloadCount = mpReloadCount;
		bHasMuzzleFlash = True;
		ReloadCount = 4;
		bHasLaser = False;

      //ReloadTime = ShotTime;
	}
}

function SpecialPTHShit(actor other, vector hitlocation, vector hitnormal, vector x, vector y, vector z)
{    
 local int j;
 local FleshFragment FF;
 
 if ((Other.IsA('Pawn')) && (hitlocation.Z >= Other.Location.Z + 24) && (ScriptedPawn(Other) == None || ScriptedPawn(Other).bCanBleed) )
 {
	  for (j=0; j<hitDamage/8; j++)
	  {
			FF = spawn(class'FleshFragment',,,hitLocation); //boom, headshot!
			FF.DrawScale = 0.75;
	  }
 }

 Super.SpecialPTHShit(Other,hitlocation,hitnormal,x,y,z);
}

defaultproperties
{
     bRicochet=True
     MaxRicochets=3
     PenetrationPower=80
     mpNoScopeMult=0.350000
     LowAmmoWaterMark=6
     GoverningSkill=Class'DeusEx.SkillWeaponRifle'
     NoiseLevel=2.000000
     EnviroEffective=ENVEFF_Air
     ShotTime=2.475000
     reloadTime=2.850000
     HitDamage=50
     maxRange=48000
     AccurateRange=28800
     bCanHaveScope=True
     bHasScope=True
     bCanHaveLaser=True
     bHasLaser=True
     bCanHaveSilencer=True
     bHasMuzzleFlash=False
     recoilStrength=0.600000
     bUseWhileCrouched=False
     mpReloadTime=2.850000
     mpHitDamage=50
     mpAccurateRange=28800
     mpMaxRange=28800
     mpReloadCount=4
     bCanHaveModBaseAccuracy=True
     bCanHaveModReloadCount=True
     bCanHaveModAccurateRange=True
     bCanHaveModReloadTime=True
     bCanHaveModRecoilStrength=True
     AmmoName=Class'MarkistanCity.MSCAmmo50Cal'
     ReloadCount=4
     PickupAmmoCount=12
     bInstantHit=True
     FireOffset=(X=-20.000000,Y=2.000000,Z=30.000000)
     shakemag=50.000000
     FireSound=Sound'BarrettFire'
     AltFireSound=Sound'DeusExSounds.Weapons.RifleReloadEnd'
     CockingSound=Sound'DeusExSounds.Weapons.RifleReload'
     SelectSound=Sound'DeusExSounds.Weapons.RifleSelect'
     InventoryGroup=195
     ItemName="M-95 Barrett"
     ItemArticle="an"
     PlayerViewOffset=(X=20.000000,Y=-2.000000,Z=-30.000000)
     PlayerViewMesh=LodMesh'DeusExItems.SniperRifle'
     PickupViewMesh=LodMesh'DeusExItems.SniperRiflePickup'
     ThirdPersonMesh=LodMesh'DeusExItems.SniperRifle3rd'
     LandSound=Sound'DeusExSounds.Generic.DropMediumWeapon'
     Icon=Texture'DeusExUI.Icons.BeltIconRifle'
     largeIcon=Texture'DeusExUI.Icons.LargeIconRifle'
     largeIconWidth=159
     largeIconHeight=47
     invSlotsX=4
     Description="The M-95 barret is legendary. It holds superior power while maintaining good accuracy although it has high recoil and small clip capacity; most things shot with this will not live."
     beltDescription="BARRETT"
     Mesh=LodMesh'DeusExItems.SniperRiflePickup'
     CollisionRadius=26.000000
     CollisionHeight=2.000000
     Mass=30.000000
}
