//=============================================================================
// WeaponDragunov.
//=============================================================================
class WeaponDragunov extends MarkistanCityGuns;

var float	mpNoScopeMult;

simulated function PreBeginPlay()
{
	Super.PreBeginPlay();

	// If this is a netgame, then override defaults
	if ( Level.NetMode != NM_StandAlone )
	{
		HitDamage = mpHitDamage;
		BaseAccuracy = mpBaseAccuracy;
		ReloadTime = mpReloadTime;
		AccurateRange = mpAccurateRange;
		MaxRange = mpMaxRange;
		ReloadCount = mpReloadCount;
		bHasMuzzleFlash = True;
		ReloadCount = 8;
		bHasLaser = False;

      //ReloadTime = ShotTime;
	}
}

function SpecialPTHShit(actor other, vector hitlocation, vector hitnormal, vector x, vector y, vector z)
{    
 local int j;
 local FleshFragment FF;
 
 if ((Other.IsA('Pawn')) && (hitlocation.Z >= Other.Location.Z + 24) && (ScriptedPawn(Other) == None || ScriptedPawn(Other).bCanBleed) )
 {
	  for (j=0; j<hitDamage/8; j++)
	  {
			FF = spawn(class'FleshFragment',,,hitLocation); //boom, headshot!
			FF.DrawScale = 0.75;
	  }
 }

 Super.SpecialPTHShit(Other,hitlocation,hitnormal,x,y,z);
}


//+++++++++++++
//Icons
//+++++++++++++
#exec TEXTURE IMPORT NAME=BeltIconDragunov FILE=Textures\BeltIconDragunovFIN.PCX GROUP=Icons //Belt
#exec TEXTURE IMPORT NAME=InventoryIconDragunov FILE=Textures\InventoryIconDragunovFIN.PCX GROUP=Icons //Inventory

//-------------
//Sounds
//-------------
#exec AUDIO IMPORT FILE="C:\DeusEx\MarkistanCity\Sounds\SniperFire.wav" NAME="DragunovFire" GROUP="Weapons"

defaultproperties
{
     bRicochet=True
     MaxRicochets=3
     PenetrationPower=48
     mpNoScopeMult=0.350000
     LowAmmoWaterMark=6
     GoverningSkill=Class'DeusEx.SkillWeaponRifle'
     NoiseLevel=2.000000
     EnviroEffective=ENVEFF_Air
     ShotTime=0.950000
     reloadTime=3.250000
     HitDamage=35
     maxRange=48000
     AccurateRange=28800
     bCanHaveScope=True
     bHasScope=True
     bCanHaveLaser=True
     bHasLaser=True
     bCanHaveSilencer=True
     bHasMuzzleFlash=False
     recoilStrength=0.600000
     bUseWhileCrouched=False
     mpReloadTime=3.250000
     mpHitDamage=35
     mpAccurateRange=28800
     mpMaxRange=28800
     mpReloadCount=8
     bCanHaveModBaseAccuracy=True
     bCanHaveModReloadCount=True
     bCanHaveModAccurateRange=True
     bCanHaveModReloadTime=True
     bCanHaveModRecoilStrength=True
     AmmoName=Class'MarkistanCity.MSCAmmo762mm'
     ReloadCount=8
     PickupAmmoCount=20
     bInstantHit=True
     FireOffset=(X=-20.000000,Y=2.000000,Z=30.000000)
     shakemag=50.000000
     FireSound=Sound'DragunovFire'
     AltFireSound=Sound'DeusExSounds.Weapons.RifleReloadEnd'
     CockingSound=Sound'DeusExSounds.Weapons.RifleReload'
     SelectSound=Sound'DeusExSounds.Weapons.RifleSelect'
     InventoryGroup=201 
     ItemName="Dragunov Sniper Rifle"
     ItemArticle="a"
     PlayerViewOffset=(X=20.000000,Y=-2.000000,Z=-30.000000)
     PlayerViewMesh=LodMesh'DeusExItems.SniperRifle'
     PickupViewMesh=LodMesh'DeusExItems.SniperRiflePickup'
     ThirdPersonMesh=LodMesh'DeusExItems.SniperRifle3rd'
     LandSound=Sound'DeusExSounds.Generic.DropMediumWeapon'
     Icon=Texture'BeltIconDragunov'
     largeIcon=Texture'InventoryIconDragunov'
     largeIconWidth=192
     largeIconHeight=52
     invSlotsX=4
     Description="The Dragunov sniper rifle was created by Russia in the 20th century, it holds less power but larger capacity and faster firing compared to the barrett."
     beltDescription="DRAGUNOV"
     Mesh=LodMesh'DeusExItems.SniperRiflePickup'
     CollisionRadius=26.000000
     CollisionHeight=2.000000
     Mass=30.000000
}
